/* A Bison parser, made from vcc.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse versit_parse
#define yylex versit_lex
#define yyerror versit_error
#define yylval versit_lval
#define yychar versit_char
#define yydebug versit_debug
#define yynerrs versit_nerrs
# define	EQ	257
# define	COLON	258
# define	DOT	259
# define	SEMICOLON	260
# define	SPACE	261
# define	HTAB	262
# define	LINESEP	263
# define	NEWLINE	264
# define	BEGIN_VCARD	265
# define	END_VCARD	266
# define	BEGIN_VCAL	267
# define	END_VCAL	268
# define	BEGIN_VEVENT	269
# define	END_VEVENT	270
# define	BEGIN_VTODO	271
# define	END_VTODO	272
# define	BEGIN_VALARM	273
# define	END_VALARM	274
# define	ID	275
# define	STRING	276

#line 1 "vcc.y"


/***************************************************************************
(C) Copyright 1996 Apple Computer, Inc., AT&T Corp., International
Business Machines Corporation and Siemens Rolm Communications Inc.

For purposes of this license notice, the term Licensors shall mean,
collectively, Apple Computer, Inc., AT&T Corp., International
Business Machines Corporation and Siemens Rolm Communications Inc.
The term Licensor shall mean any of the Licensors.

Subject to acceptance of the following conditions, permission is hereby
granted by Licensors without the need for written agreement and without
license or royalty fees, to use, copy, modify and distribute this
software for any purpose.

The above copyright notice and the following four paragraphs must be
reproduced in all copies of this software and any software including
this software.

THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS AND NO LICENSOR SHALL HAVE
ANY OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS OR
MODIFICATIONS.

IN NO EVENT SHALL ANY LICENSOR BE LIABLE TO ANY PARTY FOR DIRECT,
INDIRECT, SPECIAL OR CONSEQUENTIAL DAMAGES OR LOST PROFITS ARISING OUT
OF THE USE OF THIS SOFTWARE EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.

EACH LICENSOR SPECIFICALLY DISCLAIMS ANY WARRANTIES, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO ANY WARRANTY OF NONINFRINGEMENT OR THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE.

The software is provided with RESTRICTED RIGHTS.  Use, duplication, or
disclosure by the government are subject to restrictions set forth in
DFARS 252.227-7013 or 48 CFR 52.227-19, as applicable.

***************************************************************************/

/*
 * src: vcc.c
 * doc: Parser for vCard and vCalendar. Note that this code is
 * generated by a yacc parser generator. Generally it should not
 * be edited by hand. The real source is vcc.y. The #line directives
 * can be commented out here to make it easier to trace through
 * in a debugger. However, if a bug is found it should
 * be fixed in vcc.y and this file regenerated.
 */


/* debugging utilities */
#if __DEBUG
#define DBG_(x) printf x
#else
#define DBG_(x)
#endif

/****  External Functions  ****/

/* assign local name to parser variables and functions so that
   we can use more than one yacc based parser.
*/

#define yyparse mimeO_parse
#define yylex mimeO_lex
#define yyerror mimeO_error
#define yychar mimeO_char
/* #define p_yyval p_mimeO_val */
#undef yyval
#define yyval mimeO_yyval
/* #define p_yylval p_mimeO_lval */
#undef yylval
#define yylval mimeO_yylval
#define yydebug mimeO_debug
#define yynerrs mimeO_nerrs
#define yyerrflag mimeO_errflag
#define yyss mimeO_ss
#define yyssp mimeO_ssp
#define yyvs mimeO_vs
#define yyvsp mimeO_vsp
#define yylhs mimeO_lhs
#define yylen mimeO_len
#define yydefred mimeO_defred
#define yydgoto mimeO_dgoto
#define yysindex mimeO_sindex
#define yyrindex mimeO_rindex
#define yygindex mimeO_gindex
#define yytable mimeO_table
#define yycheck mimeO_check
#define yyname mimeO_name
#define yyrule mimeO_rule
#define YYPREFIX "mimeO_"


#ifndef _NO_LINE_FOLDING
#define _SUPPORT_LINE_FOLDING 1
#endif

/* undef below if compile with MFC */
/* #define INCLUDEMFC 1 */

#if defined(WIN32) || defined(_WIN32)
#ifdef INCLUDEMFC
#include <afx.h>
#endif
#endif

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "vcc.h"

static int yylex(void);
static void yyerror(char *s);

/****  Types, Constants  ****/

#define YYDEBUG		1	/* 1 to compile in some debugging code */
#define MAXTOKEN	256	/* maximum token (line) length */
#define YYSTACKSIZE 	50	/* ~unref ? */
#define MAXLEVEL	10	/* max # of nested objects parseable */
				/* (includes outermost) */


/****  Global Variables  ****/
int mimeO_lineNum, mimeO_numErrors; /* yyerror() can use these */
static VObjectO* vObjListO;
static VObjectO *curPropO;
static VObjectO *curObjO;
static VObjectO* ObjStackO[MAXLEVEL];
static int ObjStackTopO;


/* A helpful utility for the rest of the app. */
#if __CPLUSPLUS__
extern "C" {
#endif

    extern void Parse_DebugO(const char *s);
    extern void yyerror(char *s);

#if __CPLUSPLUS__
    };
#endif

int yyparse(void);

enum LexModeO {
	L_NORMAL,
	L_VCARD,
	L_VCAL,
	L_VEVENT,
	L_VTODO,
        L_VALARM,
	L_VALUES,
	L_BASE64,
	L_QUOTED_PRINTABLE
	};

/****  Private Forward Declarations  ****/
static int pushVObjectO(const char *prop);
static VObjectO* popVObjectO(void);
#ifndef _SUPPORT_LINE_FOLDING
static char* lexDataFromBase64O(void);
#endif
static void lexPopModeO(int top);
static int lexWithinModeO(enum LexModeO mode);
static void lexPushModeO(enum LexModeO mode);
static void enterPropsO(const char *s);
static void enterAttrO(const char *s1, const char *s2);
#if 0
static void enterValuesO(const char *value);
#endif
static void mimeO_error_(char *s);
 static void appendValueO(const char *value);

static int
ascii_tolower(const char i) {
	if ('A' <= i && i <= 'Z')
		return i - ('A' - 'a');
	return i;
}

static int
ascii_stricmp(const char* s1, const char* s2) {
	const char *p = s1, *q = s2;
	while (*p || *q) {
		char c1 = ascii_tolower(*p++);
		char c2 = ascii_tolower(*q++);
		if (c1 < c2)
			return -1;
		if (c1 > c2)
			return 1;
	}
	return 0;
}


#line 206 "vcc.y"
#ifndef YYSTYPE
typedef union {
    char *str;
    VObjectO *vobj;
    } yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		70
#define	YYFLAG		-32768
#define	YYNTBASE	23

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 276 ? yytranslate[x] : 57)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     3,     7,     9,    11,    13,    14,    19,
      20,    24,    27,    29,    30,    36,    38,    39,    43,    45,
      48,    50,    53,    55,    59,    61,    62,    67,    69,    71,
      72,    73,    78,    79,    83,    86,    88,    90,    92,    94,
      96,    99,   100,   105,   106,   110,   111,   116,   117,   121,
     122,   127,   128
};
static const short yyrhs[] =
{
      24,     0,     0,    26,    25,    24,     0,    26,     0,    27,
       0,    42,     0,     0,    11,    28,    30,    12,     0,     0,
      11,    29,    12,     0,    31,    30,     0,    31,     0,     0,
      33,     4,    32,    39,     9,     0,     1,     0,     0,    38,
      34,    35,     0,    38,     0,    36,    35,     0,    36,     0,
       6,    37,     0,    38,     0,    38,     3,    38,     0,    21,
       0,     0,    41,     6,    40,    39,     0,    41,     0,    22,
       0,     0,     0,    13,    43,    45,    14,     0,     0,    13,
      44,    14,     0,    46,    45,     0,    46,     0,    48,     0,
      51,     0,    30,     0,    30,     0,    30,    54,     0,     0,
      15,    49,    47,    16,     0,     0,    15,    50,    16,     0,
       0,    17,    52,    30,    18,     0,     0,    17,    53,    18,
       0,     0,    19,    55,    30,    20,     0,     0,    19,    56,
      20,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   235,   238,   238,   241,   245,   246,   249,   249,   260,
     260,   272,   273,   276,   276,   286,   289,   289,   294,   300,
     301,   304,   307,   311,   318,   321,   321,   322,   326,   327,
     330,   330,   336,   336,   342,   343,   346,   348,   349,   352,
     354,   357,   357,   369,   369,   381,   381,   393,   393,   405,
     405,   417,   417
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "EQ", "COLON", "DOT", "SEMICOLON", "SPACE", 
  "HTAB", "LINESEP", "NEWLINE", "BEGIN_VCARD", "END_VCARD", "BEGIN_VCAL", 
  "END_VCAL", "BEGIN_VEVENT", "END_VEVENT", "BEGIN_VTODO", "END_VTODO", 
  "BEGIN_VALARM", "END_VALARM", "ID", "STRING", "mime", "vobjects", "@1", 
  "vobject", "vcard", "@2", "@3", "items", "item", "@4", "prop", "@5", 
  "attr_params", "attr_param", "attr", "name", "values", "@6", "value", 
  "vcal", "@7", "@8", "calitems", "calitem", "eventitems", "eventitem", 
  "@9", "@10", "todoitem", "@11", "@12", "alarmitem", "@13", "@14", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    23,    25,    24,    24,    26,    26,    28,    27,    29,
      27,    30,    30,    32,    31,    31,    34,    33,    33,    35,
      35,    36,    37,    37,    38,    40,    39,    39,    41,    41,
      43,    42,    44,    42,    45,    45,    46,    46,    46,    47,
      47,    49,    48,    50,    48,    52,    51,    53,    51,    55,
      54,    56,    54
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     0,     3,     1,     1,     1,     0,     4,     0,
       3,     2,     1,     0,     5,     1,     0,     3,     1,     2,
       1,     2,     1,     3,     1,     0,     4,     1,     1,     0,
       0,     4,     0,     3,     2,     1,     1,     1,     1,     1,
       2,     0,     4,     0,     3,     0,     4,     0,     3,     0,
       4,     0,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     7,    30,     1,     2,     5,     6,     0,     0,     0,
       0,     0,    15,    24,     0,     0,     0,    16,    10,    41,
      45,    38,     0,     0,    36,    37,    33,     3,     8,    11,
      13,     0,     0,     0,     0,     0,    31,    34,    29,     0,
      17,    20,    39,     0,    44,     0,    48,    28,     0,    27,
      21,    22,    19,    49,    40,    42,    46,    14,    25,     0,
       0,     0,    29,    23,     0,    52,    26,    50,     0,     0,
       0
};

static const short yydefgoto[] =
{
      68,     3,    11,     4,     5,     7,     8,    21,    15,    38,
      16,    31,    40,    41,    50,    17,    48,    62,    49,     6,
       9,    10,    22,    23,    43,    24,    32,    33,    25,    34,
      35,    54,    60,    61
};

static const short yypact[] =
{
      -9,    -6,   -11,-32768,     5,-32768,-32768,     8,    -5,    21,
      -1,    -9,-32768,-32768,    16,     0,    28,    29,-32768,    18,
      17,-32768,    23,     9,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    33,     8,    24,     8,    25,-32768,-32768,    19,    26,
  -32768,    33,    27,    32,-32768,    31,-32768,-32768,    35,    39,
  -32768,    47,-32768,    34,-32768,-32768,-32768,-32768,-32768,    26,
       8,    36,    19,-32768,    37,-32768,-32768,-32768,    51,    52,
  -32768
};

static const short yypgoto[] =
{
  -32768,    44,-32768,-32768,-32768,-32768,-32768,    -7,-32768,-32768,
  -32768,-32768,    20,-32768,-32768,   -28,    -4,-32768,-32768,-32768,
  -32768,-32768,    40,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768
};


#define	YYLAST		63


static const short yytable[] =
{
      14,    12,     1,   -32,     2,    -4,    -9,    18,    29,    12,
      12,    51,   -12,    26,   -12,   -12,   -12,   -12,   -12,   -12,
     -12,    13,    12,   -35,    19,    42,    20,    45,    28,    13,
      13,    63,    30,   -18,   -43,   -47,    19,    36,    20,    39,
      44,    47,    13,    46,    57,    58,    53,    13,    55,    56,
      59,    69,    70,    64,   -51,    27,    65,    67,    66,     0,
       0,    52,     0,    37
};

static const short yycheck[] =
{
       7,     1,    11,    14,    13,     0,    12,    12,    15,     1,
       1,    39,    12,    14,    14,    15,    16,    17,    18,    19,
      20,    21,     1,    14,    15,    32,    17,    34,    12,    21,
      21,    59,     4,     4,    16,    18,    15,    14,    17,     6,
      16,    22,    21,    18,     9,     6,    19,    21,    16,    18,
       3,     0,     0,    60,    20,    11,    20,    20,    62,    -1,
      -1,    41,    -1,    23
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 2:
#line 239 "vcc.y"
{ addListO(&vObjListO, yyvsp[0].vobj); curObjO = 0; }
    break;
case 4:
#line 242 "vcc.y"
{ addListO(&vObjListO, yyvsp[0].vobj); curObjO = 0; }
    break;
case 7:
#line 251 "vcc.y"
{
	lexPushModeO(L_VCARD);
	if (!pushVObjectO(VCCardPropO)) YYERROR;
	}
    break;
case 8:
#line 256 "vcc.y"
{
	lexPopModeO(0);
	yyval.vobj = popVObjectO();
	}
    break;
case 9:
#line 261 "vcc.y"
{
	lexPushModeO(L_VCARD);
	if (!pushVObjectO(VCCardPropO)) YYERROR;
	}
    break;
case 10:
#line 266 "vcc.y"
{
	lexPopModeO(0);
	yyval.vobj = popVObjectO();
	}
    break;
case 13:
#line 277 "vcc.y"
{
	lexPushModeO(L_VALUES);
	}
    break;
case 14:
#line 281 "vcc.y"
{
	if (lexWithinModeO(L_BASE64) || lexWithinModeO(L_QUOTED_PRINTABLE))
	   lexPopModeO(0);
	lexPopModeO(0);
	}
    break;
case 16:
#line 290 "vcc.y"
{
	enterPropsO(yyvsp[0].str);
	}
    break;
case 18:
#line 295 "vcc.y"
{
	enterPropsO(yyvsp[0].str);
	}
    break;
case 22:
#line 308 "vcc.y"
{
	enterAttrO(yyvsp[0].str,0);
	}
    break;
case 23:
#line 312 "vcc.y"
{
	enterAttrO(yyvsp[-2].str,yyvsp[0].str);

	}
    break;
case 25:
#line 321 "vcc.y"
{ appendValueO(yyvsp[-1].str); }
    break;
case 27:
#line 323 "vcc.y"
{ appendValueO(yyvsp[0].str); }
    break;
case 29:
#line 327 "vcc.y"
{ yyval.str = 0; }
    break;
case 30:
#line 332 "vcc.y"
{ if (!pushVObjectO(VCCalPropO)) YYERROR; }
    break;
case 31:
#line 335 "vcc.y"
{ yyval.vobj = popVObjectO(); }
    break;
case 32:
#line 337 "vcc.y"
{ if (!pushVObjectO(VCCalPropO)) YYERROR; }
    break;
case 33:
#line 339 "vcc.y"
{ yyval.vobj = popVObjectO(); }
    break;
case 41:
#line 359 "vcc.y"
{
	lexPushModeO(L_VEVENT);
	if (!pushVObjectO(VCEventPropO)) YYERROR;
	}
    break;
case 42:
#line 365 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
case 43:
#line 370 "vcc.y"
{
	lexPushModeO(L_VEVENT);
	if (!pushVObjectO(VCEventPropO)) YYERROR;
	}
    break;
case 44:
#line 375 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
case 45:
#line 383 "vcc.y"
{
	lexPushModeO(L_VTODO);
	if (!pushVObjectO(VCTodoPropO)) YYERROR;
	}
    break;
case 46:
#line 389 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
case 47:
#line 394 "vcc.y"
{
	lexPushModeO(L_VTODO);
	if (!pushVObjectO(VCTodoPropO)) YYERROR;
	}
    break;
case 48:
#line 399 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
case 49:
#line 407 "vcc.y"
{
	lexPushModeO(L_VALARM);
	if (!pushVObjectO(VCAlarmPropO)) YYERROR;
	}
    break;
case 50:
#line 413 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
case 51:
#line 418 "vcc.y"
{
	lexPushModeO(L_VALARM);
	if (!pushVObjectO(VCAlarmPropO)) YYERROR;
	}
    break;
case 52:
#line 423 "vcc.y"
{
	lexPopModeO(0);
	popVObjectO();
	}
    break;
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 429 "vcc.y"

/* ///////////////////////////////////////////////////////////////////////// */
static int pushVObjectO(const char *prop)
    {
    VObjectO *newObj;
    if (ObjStackTopO == MAXLEVEL)
	return FALSE;

    ObjStackO[++ObjStackTopO] = curObjO;

    if (curObjO) {
        newObj = addPropO(curObjO,prop);
        curObjO = newObj;
	}
    else
	curObjO = newVObjectO(prop);

    return TRUE;
    }


/* ///////////////////////////////////////////////////////////////////////// */
/* This pops the recently built vCard off the stack and returns it. */
static VObjectO* popVObjectO()
    {
    VObjectO *oldObj;
    if (ObjStackTopO < 0) {
	yyerror("pop on empty Object Stack\n");
	return 0;
	}
    oldObj = curObjO;
    curObjO = ObjStackO[ObjStackTopO--];

    return oldObj;
    }

static void appendValueO(const char *value)
{
  char *p1, *p2;
  wchar_t *p3;
  int i;

  if (fieldedPropO && *fieldedPropO) {
    if (value) {
      addPropValueO(curPropO, *fieldedPropO, value);
    }
    /* else this field is empty, advance to next field */
    fieldedPropO++;
  } else {
    if (value) {
      if (vObjectUStringZValueO(curPropO)) {
	p1 = fakeCStringO(vObjectUStringZValueO(curPropO));
	p2 = malloc(sizeof(char *) * (strlen(p1)+strlen(value)+1));
	strcpy(p2, p1);
	deleteStrO(p1);

	i = strlen(p2);
	p2[i] = ';';
	p2[i+1] = '\0';
	p2 = strcat(p2, value);
	p3 = (wchar_t *) vObjectUStringZValueO(curPropO);
	free(p3);
	setVObjectUStringZValue_O(curPropO,fakeUnicodeO(p2,0));
	deleteStrO(p2);
      } else {
	setVObjectUStringZValue_O(curPropO,fakeUnicodeO(value,0));
      }
    }
    else {
      setVObjectNullValueO(curPropO);
    }
  }
  deleteStrO(value);
}


static void enterPropsO(const char *s)
    {
    curPropO = addGroupO(curObjO,s);
    deleteStrO(s);
    }

static void enterAttrO(const char *s1, const char *s2)
    {
    const char *p1, *p2 = NULL;
    p1 = lookupProp_O(s1);
    if (s2) {
	VObjectO *a;
	p2 = lookupProp_O(s2);
	a = addPropO(curPropO,p1);
	setVObjectStringZValueO(a,p2);
	}
    else
	addPropO(curPropO,p1);
    if (ascii_stricmp(p1,VCBase64PropO) == 0 || (s2 && ascii_stricmp(p2,VCBase64PropO)==0))
	lexPushModeO(L_BASE64);
    else if (ascii_stricmp(p1,VCQuotedPrintablePropO) == 0
	    || (s2 && ascii_stricmp(p2,VCQuotedPrintablePropO)==0))
	lexPushModeO(L_QUOTED_PRINTABLE);
    deleteStrO(s1); deleteStrO(s2);
    }


/* #define MAX_LEX_LOOKAHEAD_0 64 */
#define MAX_LEX_LOOKAHEAD 256
#define MAX_LEX_MODE_STACK_SIZE 10
#define LEXMODE() (lexBufO.lexModeStack[lexBufO.lexModeStackTop])

struct LexBufO {
	/* input */
#ifdef INCLUDEMFC
    CFile *inputFile;
#else
    FILE *inputFile;
#endif
    char *inputString;
    unsigned long curPos;
    unsigned long inputLen;
	/* lookahead buffer */
	/*   -- lookahead buffer is int instead of char so that EOF
	 /      can be represented correctly.
	*/
    unsigned long len;
    int buf[MAX_LEX_LOOKAHEAD];
    unsigned long getPtr;
	/* context stack */
    unsigned long lexModeStackTop;
    enum LexModeO lexModeStack[MAX_LEX_MODE_STACK_SIZE];
	/* token buffer */
    unsigned long maxToken;
    char *strs;
    unsigned long strsLen;
    } lexBufO;

static void lexPushModeO(enum LexModeO mode)
    {
    if (lexBufO.lexModeStackTop == (MAX_LEX_MODE_STACK_SIZE-1))
	yyerror("lexical context stack overflow");
    else {
	lexBufO.lexModeStack[++lexBufO.lexModeStackTop] = mode;
	}
    }

static void lexPopModeO(int top)
    {
    /* special case of pop for ease of error recovery -- this
	version will never underflow */
    if (top)
	lexBufO.lexModeStackTop = 0;
    else
	if (lexBufO.lexModeStackTop > 0) lexBufO.lexModeStackTop--;
    }

static int lexWithinModeO(enum LexModeO mode) {
    unsigned long i;
    for (i=0;i<lexBufO.lexModeStackTop;i++)
	if (mode == lexBufO.lexModeStack[i]) return 1;
    return 0;
    }

static int lexGetc_O()
    {
    /* get next char from input, no buffering. */
    if (lexBufO.curPos == lexBufO.inputLen)
	return EOF;
    else if (lexBufO.inputString)
	return *(lexBufO.inputString + lexBufO.curPos++);
    else {
#ifdef INCLUDEMFC
	char result;
	return lexBufO.inputFile->Read(&result, 1) == 1 ? result : EOF;
#else
	return fgetc(lexBufO.inputFile);
#endif
	}
    }

static int lexGetaO()
    {
    ++lexBufO.len;
    return (lexBufO.buf[lexBufO.getPtr] = lexGetc_O());
    }

static int lexGeta_O(int i)
    {
    ++lexBufO.len;
    return (lexBufO.buf[(lexBufO.getPtr+i)%MAX_LEX_LOOKAHEAD] = lexGetc_O());
    }

static void lexSkipLookaheadO() {
    if (lexBufO.len > 0 && lexBufO.buf[lexBufO.getPtr]!=EOF) {
	/* don't skip EOF. */
        lexBufO.getPtr = (lexBufO.getPtr + 1) % MAX_LEX_LOOKAHEAD;
	lexBufO.len--;
        }
    }

static int lexLookaheadO() {
    int c = (lexBufO.len)?
	lexBufO.buf[lexBufO.getPtr]:
	lexGetaO();
    /* do the \r\n -> \n or \r -> \n translation here */
    if (c == '\r') {
	int a = (lexBufO.len>1)?
	    lexBufO.buf[(lexBufO.getPtr+1)%MAX_LEX_LOOKAHEAD]:
	    lexGeta_O(1);
	if (a == '\n') {
	    lexSkipLookaheadO();
	    }
	lexBufO.buf[lexBufO.getPtr] = c = '\n';
	}
    else if (c == '\n') {
	int a = (lexBufO.len>1)?
	    lexBufO.buf[lexBufO.getPtr+1]:
	    lexGeta_O(1);
	if (a == '\r') {
	    lexSkipLookaheadO();
	    }
	lexBufO.buf[lexBufO.getPtr] = '\n';
	}
    return c;
    }

static int lexGetcO() {
    int c = lexLookaheadO();
    if (lexBufO.len > 0 && lexBufO.buf[lexBufO.getPtr]!=EOF) {
	/* EOF will remain in lookahead buffer */
        lexBufO.getPtr = (lexBufO.getPtr + 1) % MAX_LEX_LOOKAHEAD;
	lexBufO.len--;
        }
    return c;
    }

static void lexSkipLookaheadWordO() {
    if (lexBufO.strsLen <= lexBufO.len) {
	lexBufO.len -= lexBufO.strsLen;
	lexBufO.getPtr = (lexBufO.getPtr + lexBufO.strsLen) % MAX_LEX_LOOKAHEAD;
	}
    }

static void lexClearTokenO()
    {
    lexBufO.strsLen = 0;
    }

static void lexAppendcO(int c)
    {
    lexBufO.strs[lexBufO.strsLen] = c;
    /* append up to zero termination */
    if (c == 0) return;
    lexBufO.strsLen++;
    if (lexBufO.strsLen >= lexBufO.maxToken) {
	/* double the token string size */
	lexBufO.maxToken <<= 1;
	lexBufO.strs = (char*) realloc(lexBufO.strs,(size_t)lexBufO.maxToken);
	}
    }

static char* lexStrO() {
    return dupStrO(lexBufO.strs,(size_t)lexBufO.strsLen+1);
    }

static void lexSkipWhiteO() {
    int c = lexLookaheadO();
    while (c == ' ' || c == '\t') {
	lexSkipLookaheadO();
	c = lexLookaheadO();
	}
    }

static char* lexGetWordO() {
    int c;
    lexSkipWhiteO();
    lexClearTokenO();
    c = lexLookaheadO();
    while (c != EOF && !strchr("\t\n ;:=",c)) {
	lexAppendcO(c);
	lexSkipLookaheadO();
	c = lexLookaheadO();
	}
    lexAppendcO(0);
    return lexStrO();
    }


static void lexPushLookaheadcO(int c) {
    int putptr;
    /* can't putback EOF, because it never leaves lookahead buffer */
    if (c == EOF) return;
    putptr = (int)lexBufO.getPtr - 1;
    if (putptr < 0) putptr += MAX_LEX_LOOKAHEAD;
    lexBufO.getPtr = putptr;
    lexBufO.buf[putptr] = c;
    lexBufO.len += 1;
    }

static char* lexLookaheadWordO() {
    /* this function can lookahead word with max size of MAX_LEX_LOOKAHEAD
     /  and thing bigger than that will stop the lookahead and return 0;
     / leading white spaces are not recoverable.
     */
    int c;
    int len = 0;
    int curgetptr = 0;
    lexSkipWhiteO();
    lexClearTokenO();
    curgetptr = (int)lexBufO.getPtr;	/* remember! */
    while (len < (MAX_LEX_LOOKAHEAD)) {
	c = lexGetcO();
	len++;
	if (c == EOF || strchr("\t\n ;:=", c)) {
	    lexAppendcO(0);
	    /* restore lookahead buf. */
	    lexBufO.len += len;
	    lexBufO.getPtr = curgetptr;
	    return lexStrO();
	    }
        else
	    lexAppendcO(c);
	}
    lexBufO.len += len;	/* char that has been moved to lookahead buffer */
    lexBufO.getPtr = curgetptr;
    return 0;
    }
    
static char* lexLookaheadUntilO(const char* lookfor)
{
  /* this function can lookahead until lookfor with max size of MAX_LEX_LOOKAHEAD
   * anything bigger than that will stop the lookahead and return 0;
   * leading white spaces are not recoverable.
   */
  int c;
  int len = 0;
  int curgetptr = 0;
  lexSkipWhiteO();
  lexClearTokenO();
  curgetptr = (int)lexBufO.getPtr;	/* remember! */
  while (len < (MAX_LEX_LOOKAHEAD)) 
  {
    c = lexGetcO();
    len++;
    if (c == EOF || strchr(lookfor, c)) 
    {
      lexAppendcO(0);
      /* restore lookahead buf. */
      lexBufO.len += len;
      lexBufO.getPtr = curgetptr;
      return lexStrO();
    }
    else
    {
      lexAppendcO(c);
    }
  }
  lexBufO.len += len;	/* char that has been moved to lookahead buffer */
  lexBufO.getPtr = curgetptr;
  return 0;
  
}    

#ifdef _SUPPORT_LINE_FOLDING
static void handleMoreRFC822LineBreakO(int c) {
    /* suport RFC 822 line break in cases like
     *	ADR: foo;
     *    morefoo;
     *    more foo;
     */
    if (c == ';') {
	int a;
	lexSkipLookaheadO();
	/* skip white spaces */
	a = lexLookaheadO();
	while (a == ' ' || a == '\t') {
	    lexSkipLookaheadO();
	    a = lexLookaheadO();
	    }
	if (a == '\n') {
	    lexSkipLookaheadO();
	    a = lexLookaheadO();
	    if (a == ' ' || a == '\t') {
		/* continuation, throw away all the \n and spaces read so
		 * far
		 */
		lexSkipWhiteO();
		lexPushLookaheadcO(';');
		}
	    else {
		lexPushLookaheadcO('\n');
		lexPushLookaheadcO(';');
		}
	    }
	else {
	    lexPushLookaheadcO(';');
	    }
	}
    }

static char* lexGet1ValueO() {
    int c;
    lexSkipWhiteO();
    c = lexLookaheadO();
    lexClearTokenO();
    while (c != EOF && c != ';') {
	if (c == '\n') {
	    int a;
	    lexSkipLookaheadO();
	    a  = lexLookaheadO();
	    if (a == ' ' || a == '\t') {
		lexAppendcO(' ');
		lexSkipLookaheadO();
		}
	    else {
		lexPushLookaheadcO('\n');
		break;
		}
	    }
	else {
	    lexAppendcO(c);
	    lexSkipLookaheadO();
	    }
	c = lexLookaheadO();
	}
    lexAppendcO(0);
    handleMoreRFC822LineBreakO(c);
    return c==EOF?0:lexStrO();
    }
#endif

#ifndef _SUPPORT_LINE_FOLDING
static char* lexGetStrUntilO(char *termset) {
    int c = lexLookaheadO();
    lexClearToken();
    while (c != EOF && !strchr(termset,c)) {
	lexAppendcO(c);
	lexSkipLookaheadO();
	c = lexLookaheadO();
	}
    lexAppendcO(0);
    return c==EOF?0:lexStr();
    }
#endif

static int match_begin_nameO(int end) {
    char *n = lexLookaheadWordO();
    int token = ID;
    
    if (n) {
	if (!ascii_stricmp(n,"vcard")) token = end?END_VCARD:BEGIN_VCARD;
	else if (!ascii_stricmp(n,"vcalendar")) token = end?END_VCAL:BEGIN_VCAL;
	else if (!ascii_stricmp(n,"vevent")) token = end?END_VEVENT:BEGIN_VEVENT;
	else if (!ascii_stricmp(n,"vtodo")) token = end?END_VTODO:BEGIN_VTODO;
	else if (!ascii_stricmp(n,"valarm")) token = end?END_VALARM:BEGIN_VALARM;
	deleteStrO(n);
	return token;
	}
    return 0;
    }


#ifdef INCLUDEMFC
static void initLexO(const char *inputstring, unsigned long inputlen, CFile *inputfile)
#else
static void initLexO(const char *inputstring, unsigned long inputlen, FILE *inputfile)
#endif
    {
    /* initialize lex mode stack */
    lexBufO.lexModeStack[lexBufO.lexModeStackTop=0] = L_NORMAL;

    /* iniatialize lex buffer. */
    lexBufO.inputString = (char*) inputstring;
    lexBufO.inputLen = inputlen;
    lexBufO.curPos = 0;
    lexBufO.inputFile = inputfile;

    lexBufO.len = 0;
    lexBufO.getPtr = 0;

    lexBufO.maxToken = MAXTOKEN;
    lexBufO.strs = (char*)malloc(MAXTOKEN);
    lexBufO.strsLen = 0;

    }

static void finiLexO() {
    free(lexBufO.strs);
    }


/* ///////////////////////////////////////////////////////////////////////// */
/* This parses and converts the base64 format for binary encoding into
 * a decoded buffer (allocated with new).  See RFC 1521.
 */
static char * lexGetDataFromBase64O()
    {
    unsigned long bytesLen = 0, bytesMax = 0;
    int quadIx = 0, pad = 0;
    unsigned long trip = 0;
    unsigned char b;
    int c;
    unsigned char *bytes = NULL;
    unsigned char *oldBytes = NULL;

    DBG_(("db: lexGetDataFromBase64\n"));
    while (1) {
	c = lexGetcO();
	if (c == '\n') {
	    ++mimeO_lineNum;
	    if (lexLookaheadO() == '\n') {
		/* a '\n' character by itself means end of data */
		break;
		}
	    else continue; /* ignore '\n' */
	    }
	else {
	    if ((c >= 'A') && (c <= 'Z'))
		b = (unsigned char)(c - 'A');
	    else if ((c >= 'a') && (c <= 'z'))
		b = (unsigned char)(c - 'a') + 26;
	    else if ((c >= '0') && (c <= '9'))
		b = (unsigned char)(c - '0') + 52;
	    else if (c == '+')
		b = 62;
	    else if (c == '/')
		b = 63;
	    else if (c == '=') {
		b = 0;
		pad++;
	    } else if ((c == ' ') || (c == '\t')) {
		continue;
	    } else { /* error condition */
		if (bytes) free(bytes);
		else if (oldBytes) free(oldBytes);
		/* error recovery: skip until 2 adjacent newlines. */
		DBG_(("db: invalid character 0x%x '%c'\n", c,c));
		if (c != EOF)  {
		    c = lexGetcO();
		    while (c != EOF) {
			if (c == '\n' && lexLookaheadO() == '\n') {
			    ++mimeO_lineNum;
			    break;
			    }
			c = lexGetcO();
			}
		    }
		return NULL;
		}
	    trip = (trip << 6) | b;
	    if (++quadIx == 4) {
		unsigned char outBytes[3];
		int numOut;
		int i;
		for (i = 0; i < 3; i++) {
		    outBytes[2-i] = (unsigned char)(trip & 0xFF);
		    trip >>= 8;
		    }
		numOut = 3 - pad;
		if (bytesLen + numOut > bytesMax) {
		    if (!bytes) {
			bytesMax = 1024;
			bytes = (unsigned char*)malloc((size_t)bytesMax);
			}
		    else {
			bytesMax <<= 2;
			oldBytes = bytes;
			bytes = (unsigned char*)realloc(bytes,(size_t)bytesMax);
			}
		    if (bytes == 0) {
			mimeO_error("out of memory while processing BASE64 data\n");
			}
		    }
		if (bytes) {
		    memcpy(bytes + bytesLen, outBytes, numOut);
		    bytesLen += numOut;
		    }
		trip = 0;
		quadIx = 0;
		}
	    }
	} /* while */
    DBG_(("db: bytesLen = %d\n",  bytesLen));
    /* kludge: all this won't be necessary if we have tree form
	representation */
    if (bytes) {
	setValueWithSizeO(curPropO,bytes,(unsigned int)bytesLen);
	free(bytes);
	}
    else if (oldBytes) {
	setValueWithSizeO(curPropO,oldBytes,(unsigned int)bytesLen);
	free(oldBytes);
	}
    return 0;
    }

static int match_begin_end_nameO(int end) {
    int token;
    lexSkipWhiteO();
    if (lexLookaheadO() != ':') return ID;
    lexSkipLookaheadO();
    lexSkipWhiteO();
    token = match_begin_nameO(end);
    if (token == ID) {
	lexPushLookaheadcO(':');
	DBG_(("db: ID '%s'\n", yylval.str));
	return ID;
	}
    else if (token != 0) {
	lexSkipLookaheadWordO();
	deleteStrO(yylval.str);
	DBG_(("db: begin/end %d\n", token));
	return token;
	}
    return 0;
    }

static char* lexGetQuotedPrintableO()
    {
    int cur;

    lexClearTokenO();
    do {
	cur = lexGetcO();
	switch (cur) {
	    case '=': {
		int c = 0;
		int next[2];
		int i;
		for (i = 0; i < 2; i++) {
		    next[i] = lexGetcO();
		    if (next[i] >= '0' && next[i] <= '9')
			c = c * 16 + next[i] - '0';
		    else if (next[i] >= 'A' && next[i] <= 'F')
			c = c * 16 + next[i] - 'A' + 10;
		    else
			break;
		    }
		if (i == 0) {
		    /* single '=' follow by LINESEP is continuation sign? */
		    if (next[0] == '\n') {
			++mimeO_lineNum;
			}
		    else {
			lexPushLookaheadcO('=');
			goto EndString;
			}
		    }
		else if (i == 1) {
		    lexPushLookaheadcO(next[1]);
		    lexPushLookaheadcO(next[0]);
		    lexAppendcO('=');
		} else {
		    lexAppendcO(c);
		    }
		break;
		} /* '=' */
	    case '\n':
	    case ';':
	      {
		lexPushLookaheadcO(cur);
		goto EndString;
		}
	    case EOF:
		break;
	    default:
		lexAppendcO(cur);
		break;
	    } /* switch */
	} while (cur != EOF);

EndString:
    lexAppendcO(0);
    return lexStrO();
    } /* LexQuotedPrintable */

static int yylex() {
    int lexmode = LEXMODE();
    if (lexmode == L_VALUES) {
	int c = lexGetcO();
	if (c == ';') {
	    DBG_(("db: SEMICOLON\n"));
	    lexPushLookaheadcO(c);
#ifdef _SUPPORT_LINE_FOLDING
	    handleMoreRFC822LineBreakO(c);
#endif
	    lexSkipLookaheadO();
	    return SEMICOLON;
	    }
	else if (strchr("\n",c)) {
	    ++mimeO_lineNum;
	    /* consume all line separator(s) adjacent to each other */
	    c = lexLookaheadO();
	    while (strchr("\n",c)) {
		lexSkipLookaheadO();
		c = lexLookaheadO();
		++mimeO_lineNum;
		}
	    DBG_(("db: LINESEP\n"));
	    return LINESEP;
	    }
	else {
	    char *p = 0;
	    lexPushLookaheadcO(c);
	    if (lexWithinModeO(L_BASE64)) {
		/* get each char and convert to bin on the fly... */
		p = lexGetDataFromBase64O();
		yylval.str = p;
		return STRING;
		}
	    else if (lexWithinModeO(L_QUOTED_PRINTABLE)) {
		p = lexGetQuotedPrintableO();
		}
	    else {
#ifdef _SUPPORT_LINE_FOLDING
		p = lexGet1ValueO();
#else
		p = lexGetStrUntilO(";\n");
#endif
		}
	    if (p) {
		DBG_(("db: STRING: '%s'\n", p));
		yylval.str = p;
		return STRING;
		}
	    else return 0;
	    }
	}
    else {
	/* normal mode */
	while (1) {
	    int c = lexGetcO();
	    switch(c) {
		case ':': {
                    /* consume a line separator after the colon if the next line
                     * does not contain a colon - i.e. a line wrap has occurred
                     */    
                    c = lexLookaheadO();
                    if(strchr("\n", c))
                    {
                      char *t = lexLookaheadUntilO(":");
                      if(t)
                      {
                        /* skip over the immediate newline */
                        ++t;
                        if(strstr(t, "\n"))
                        {
                          /* newline before the next colon - it was a line wrap */
                          /* consume the newline */
                          lexSkipLookaheadO();
                          c = lexLookaheadO();
                          ++mimeO_lineNum;
                        }
                      }
                    }    
		    DBG_(("db: COLON\n"));
		    return COLON;
		    }
		case ';':
		    DBG_(("db: SEMICOLON\n"));
		    return SEMICOLON;
		case '=':
		    DBG_(("db: EQ\n"));
		    return EQ;
		/* ignore whitespace in this mode */
		case '\t':
		case ' ': continue;
		case '\n': {
		    ++mimeO_lineNum;
		    continue;
		    }
		case EOF: return 0;
		    break;
		default: {
		    lexPushLookaheadcO(c);
		    if (isprint(c)) {
			char *t = lexGetWordO();
			yylval.str = t;
			if (!ascii_stricmp(t, "begin")) {
			    return match_begin_end_nameO(0);
			    }
			else if (!ascii_stricmp(t,"end")) {
			    return match_begin_end_nameO(1);
			    }
		        else {
			    DBG_(("db: ID '%s'\n", t));
			    return ID;
			    }
			}
		    else {
			/* unknow token */
			return 0;
			}
		    break;
		    }
		}
	    }
	}
    return 0;
    }


/***************************************************************************/
/***							Public Functions						****/
/***************************************************************************/

static VObjectO* Parse_MIMEHelperO()
    {
    ObjStackTopO = -1;
    mimeO_numErrors = 0;
    mimeO_lineNum = 1;
    vObjListO = 0;
    curObjO = 0;

    if (yyparse() != 0) {
	finiLexO();
	return 0;
    }

    finiLexO();
    return vObjListO;
    }

/* ///////////////////////////////////////////////////////////////////////// */
DLLEXPORT(VObjectO*) Parse_MIMEO(const char *input, unsigned long len)
    {
    initLexO(input, len, 0);
    return Parse_MIMEHelperO();
    }


#if INCLUDEMFC

DLLEXPORT(VObjectO*) Parse_mimeO_FromFileO(CFile *file)
    {
    unsigned long startPos;
    VObjectO *result;

    initLexO(0,-1,file);
    startPos = file->GetPosition();
    if (!(result = Parse_MIMEHelperO()))
	file->Seek(startPos, CFile::begin);
    return result;
    }

#else

VObjectO* Parse_MIME_FromFileO(FILE *file)
    {
    VObjectO *result;
    long startPos;

    initLexO(0,(unsigned long)-1,file);
    startPos = ftell(file);
    if (!(result = Parse_MIMEHelperO())) {
	fseek(file,startPos,SEEK_SET);
	}
    return result;
    }

DLLEXPORT(VObjectO*) Parse_MIME_FromFileNameO(char *fname)
    {
    FILE *fp = fopen(fname,"r");
    if (fp) {
	VObjectO* o = Parse_MIME_FromFileO(fp);
	fclose(fp);
	return o;
	}
    else {
	char msg[256];
	snprintf(msg, sizeof(msg), "can't open file '%s' for reading\n", fname);
	mimeO_error_(msg);
	return 0;
	}
    }

#endif

/* ///////////////////////////////////////////////////////////////////////// */

static MimeErrorHandlerO mimeErrorHandlerO;

DLLEXPORT(void) registerMimeErrorHandlerO(MimeErrorHandlerO me)
    {
    mimeErrorHandlerO = me;
    }

static void mimeO_error(char *s)
    {
    char msg[256];
    if (mimeErrorHandlerO) {
	sprintf(msg,"%s at line %d", s, mimeO_lineNum);
	mimeErrorHandlerO(msg);
	}
    }

static void mimeO_error_(char *s)
    {
    if (mimeErrorHandlerO) {
	mimeErrorHandlerO(s);
	}
    }


